/***************************************************************************/
/* GalacticConquest v 1.01b
 * Release date: 26 Jun 2000
 * Copyright 2000 Anatoliy Okhotnikov <cgc@tolik.8k.com>
 *		
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
/************************************************************************/
float NumPlanets=10;
int NumPlayers=2,
    NumSteps=25,
    M,N,x_gc1,y_gc1,x_gc2,y_gc2,
    PlanetStatus[MAX_PLANETS],
    PlanetCoordX[MAX_PLANETS],
    PlanetCoordY[MAX_PLANETS],
    PlanetProduct[MAX_PLANETS],
    PlanetShips[MAX_PLANETS];

unsigned char c1[MAX_PLANETS][SPACE];
unsigned char c2[MAX_PLANETS][SPACE];

char players[MAX_PLAYERS][NAME_SIZE]={
{' ',' ',' ',' ',' ',' ',' ',' ',' ',' '},
{' ',' ',' ',' ',' ',' ',' ',' ',' ',' '},
{' ',' ',' ',' ',' ',' ',' ',' ',' ',' '},
{' ',' ',' ',' ',' ',' ',' ',' ',' ',' '},
{' ',' ',' ',' ',' ',' ',' ',' ',' ',' '},
{' ',' ',' ',' ',' ',' ',' ',' ',' ',' '},
{' ',' ',' ',' ',' ',' ',' ',' ',' ',' '},
{' ',' ',' ',' ',' ',' ',' ',' ',' ',' '},
{' ',' ',' ',' ',' ',' ',' ',' ',' ',' '}};

typedef struct {
    char mapL[MAX_PLANETS][SPACE];
    char mapH[MAX_PLANETS][SPACE];
    int ships;
    int squadrons;
    int planets;
    int destroyed;
    char*name;
	    } Player;

Player GP[MAX_PLAYERS];
char tmp;
char *tmp01[MAX_PLAYERS+1];
char *tmp02[MAX_PLAYERS+1];
/* char *planets[MAX_PLANETS];*/
/****************************************************************************/
unsigned char scrn[24][62]={
{'1','-','P','l','a','n','e','t',' ','i','n','f','o',' ',' ',' ',' ','|','0','0','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','\n'},
{' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ','|','0','1','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','\n'},
{'2','-','S','e','n','d',' ','s','q','u','a','d','r','o','n',' ',' ','|','0','2','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','\n'},
{' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ','|','0','3','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','\n'},
{'3','-','C','o','u','n','t',' ','d','i','s','t','a','n','c','e',' ','|','0','4','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','\n'},
{' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ','|','0','5','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','\n'},
{'4','-','S','t','a','t','i','s','t','i','c','s',' ',' ',' ',' ',' ','|','0','6','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','\n'},
{' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ','|','0','7','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','\n'},
{'5','-','E','n','d',' ','t','u','r','n',' ',' ',' ',' ',' ',' ',' ','|','0','8','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','\n'},
{' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ','|','0','9','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','\n'},
{'0','-','G','i','v','e',' ','u','p',' ',' ',' ',' ',' ',' ',' ',' ','|','1','0','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','\n'},
{' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ','|','1','1','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','\n'},
{'G',' ','a',' ','l',' ','a',' ','c',' ','t',' ','i',' ','c',' ',' ','|','1','2','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','\n'},
{'C',' ','o',' ','n',' ','q',' ','u',' ','e',' ','s',' ','t',' ',' ','|','1','3','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','\n'},
{' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ','|','1','4','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','\n'},
{'C','o','n','s','o','l','e',' ','v','e','r','s','i','o','n',':',' ','|','1','5','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','\n'},
{' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ','|','1','6','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','\n'},
{'b','y',' ','A','.','O','k','h','o','t','n','i','k','o','v',' ',' ','|','1','7','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','\n'},
{'c','q','c','@','t','o','l','i','k','.','8','k','.','c','o','m',' ','|','1','8','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','\n'},
{'w','w','w','.','t','o','l','i','k','.','8','k','.','c','o','m',' ','|','1','9','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','\n'}};
unsigned char bottom[2][62]={
{' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ','|','-','-','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-','|','-',' '},
{'P','l','a','y','e','r',' ',' ',' ','m','o','v','e',' ','a','s','s','!',' ',' ',' ','A',' ','B',' ','C',' ','D',' ','E',' ','F',' ','G',' ','H',' ','I',' ','J',' ','K',' ','L',' ','M',' ','N',' ','O',' ','P',' ','Q',' ','R',' ','S',' ','T',' ',' ',}};

char cmpA[]={'A','B','C','D','E','F','G','H','I','J','K','L','M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z'};
char cmpL[]={'a','b','c','d','e','f','g','h','i','j','k','l','m','n','o','p','q','r','s','t','u','v','w','x','y','z'};
/*****************************************************************************/
void ParseS(char*s,int*x,int*y)
{int i,j,l,k=0;
 char s1[10],s2[10];
 i=strlen(s);
 for(j=0;j<i;j++) s1[j]=*(s+j);
 s1[j++]='\0';
 strtok(s,"0123456789");
 while(!strchr(s,cmpA[k++]));
 if(k>MAP_SIZE)
     {
      k=0;
      while(!strchr(s,cmpL[k++]));
     }
 k--;
 l=strlen(s);
 for(j=0;j<i-l;j++) s2[j]=*(s1+j+l);
 s2[i]='\0';
 l=atoi(s2);
 *x=k;
 *y=l;
 return;
}
/***************************************************************************/
void SplitNum(int num,char*r1,char*r2)
{
 unsigned char c1,c2;
 c1=(int)(num/256);
 c2=num-c1*256;
 *r1=c1;
 *r2=c2;
 return;
}
/***************************************************************************/
int MergeNum(unsigned char r1,unsigned char r2)
{
 return 256*r1+r2;
}
/***************************************************************************/
void FillMatrix(int k)
{
 int i,j;
/* for(i=0;i<NumPlanets;i++)
     for(j=0;j<SPACE;j++)
	 {
	 c1[i][j]=0;
	 c2[i][j]=0;
	 }	 */
/* printf("\nFillMatrix for player %d\n",k+1);*/
 for(i=0;i<NumPlanets;i++)
     {
     for(j=0;j<SPACE;j++)
	 { 
	 /*SplitNum(MergeNum(GP[k].*(mapH+i*MAX_PLANETS+j),GP[k].mapL[i][j]),&c1[i][j],&c2[i][j]);*/
	 c1[i][j]=GP[k].mapH[i][j];
	 c2[i][j]=GP[k].mapL[i][j];
/*	 printf("%d ",MergeNum(GP[k].mapH[i][j],GP[k].mapL[i][j]));*/
	 }
/*     printf("\n");*/
     }
/* confir_m("DEBUG");*/
 return;
}
/***************************************************************************/
void RefreshMatrix(int k)
{
 int i,j;
/* printf("\nRefreshMatrix for player %d\n",k+1);*/
 for(i=0;i<NumPlanets;i++)
     {
     for(j=0;j<SPACE;j++)
         {
/*         SplitNum(MergeNum(c1[i][j],c2[i][j]),GP[k].mapH[i][j],GP[k].mapL[i][j]);*/
           GP[k].mapH[i][j]=c1[i][j];
	   GP[k].mapL[i][j]=c2[i][j];
/*	   printf("%d ",MergeNum(GP[k].mapH[i][j],GP[k].mapH[i][j]));*/
	 }
/*     printf("\n");***/
     }
/* confir_m("DEBUG");*/
 return;
}
/***************************************************************************/
#ifdef LINUX
void clrscr(void)
{
 system(CLEAR);
 return;
}

#endif
/***************************************************************************/
int CheckCoords(int x,int y)
{
 if((x>=MAP_SIZE)||(x<0)) return 1;
 if((y>=MAP_SIZE)||(y<0)) return 1;
 return 0;
}
/***************************************************************************/

int GetPlanet(int x,int y)
{
 int i;
 if(!CheckCoords(x,y))
      for(i=0;i<NumPlanets;i++)
	 if(PlanetCoordX[i]==x)
	     if(PlanetCoordY[i]==y)
		 return i;
 return NumPlanets+1;
}
/***************************************************************************/

void draw(int ste_p,int p)
{
 int i,j,k,n,dec,sign,ndig=0;
 char tmp[10];
 for(i=0;i<MAP_SIZE;i++)
 {
     for(j=0;j<2*MAP_SIZE;j+=2)
     {
   n=GetPlanet(i,j/2);
         if(n>=NumPlanets) 
	     scrn[i][21+j]='|';
	 else 
	       scrn[i][21+j]=PlanetStatus[n]+48;
	 scrn[i][21+j+1]='-';
     }
 }
 if((!p)||(p>NumPlayers)) bottom[1][7]='X';
 else bottom[1][7]=p+48;
 clrscr(); 
 for(i=0;i<MAP_SIZE+4;i++)
      for(j=0;j<62;j++)
         printf("%c",scrn[i][j]);
 for(j=0;j<62;j++) 	 
	 
          printf("%c",bottom[0][j]);
 if((!p)||(p>NumPlayers)) printf(MESS_85);
 else printf("%s\n",players[p]);
 for(j=0;j<62;j++) 	 
         printf("%c",bottom[1][j]);
 printf(MESS_05);  printf("%s ",fcvt(ste_p+1,ndig,&dec,&sign));
 printf(MESS_06);
  printf("%s\n",fcvt(NumSteps,ndig,&dec,&sign));
 return;
}
/***************************************************************************/

/**************************************************************************/
void init(int num,int client)
{
 int i,j,x,y;
 char ch[5];
 if ((tmp01[0] = (char *) calloc(MAX_PLANETS*SPACE,sizeof(char))) == NULL)
     {	
       printf(ERROR00);
       exit(1);
     }
 memset(tmp01[0],0,(MAX_PLANETS*SPACE)-1);
 strcpy(c1,tmp01[0]);

 if ((tmp01[0] = (char *) calloc(MAX_PLANETS*SPACE,sizeof(char))) == NULL)
     {	
       printf(ERROR00);
       exit(1);
     }
 memset(tmp01[0],0,(MAX_PLANETS*SPACE)-1);
 strcpy(c2,tmp01[0]);

 for(i=0;i<MAX_PLAYERS;i++)
     {
     if ((GP[i].name = (char *) calloc(NAME_SIZE,sizeof(char))) == NULL)
	 {	
	   printf(ERROR00);
	   exit(1);
	 }
     if ((tmp01[i+1] = (char *) calloc(MAX_PLANETS*SPACE,sizeof(char))) == NULL)
	 {	
	   printf(ERROR00);
	   exit(1);
	 }
     memset(tmp01[i+1],0,(MAX_PLANETS*SPACE)-1);
     strcpy(GP[i].mapH,tmp01[i+1]);
     if ((tmp02[i+1] = (char *) calloc(MAX_PLANETS*SPACE,sizeof(char))) == NULL)
	 {	
	   printf(ERROR00);
	   exit(1);
	 }
     memset(tmp02[i+1],0,(MAX_PLANETS*SPACE)-1);
     strcpy(GP[i].mapL,tmp02[i+1]);	 
    }
 clrscr();
 if(!num)
 {
     printf(MESS_01,MAX_PLAYERS);
/*   ch[0]=getc(stdin);
     ch[1]='\0';
     if(isdigit(ch[0])) NumPlayers=atoi(ch);
     else NumPlayers=2;*/
     scanf("%i",&NumPlayers);
     if((NumPlayers>MAX_PLAYERS)||(NumPlayers<=0)) NumPlayers=2;
 }
 else NumPlayers=num;
      
 printf(MESS_25,NumPlayers);
 for(x=0;x<NumPlayers;x++)
    for(i=0;i<MAX_PLANETS;i++)
	 for(j=0;j<SPACE;j++)
	     {
	      c1[i][j]=0;
	      c2[i][j]=0; 
    	      GP[x].mapH[i][j]=0;
	      GP[x].mapL[i][j]=0;
	     }

 for(i=0;i<NumPlayers;i++)
     if((!num)||(!i))
     {
     if(client) i++;
     strcpy(players[0],MESS_04);
     printf(MESS_03,i+1,NAME_SIZE,i+1);
     scanf("%s",players[i+1]);
     if((players[i+1]==NULL)||(strlen(players[i+1])>NAME_SIZE))
         {
	 strcpy(players[i+1],"Player");
	 players[i+1][6]=49+i;
	 players[i+1][7]='\0';
	 }
     GP[i].name=players[i+1];
     printf(MESS_33,i+1,GP[i].name);
     }
 if(!client)
 {     
     printf(MESS_02,MAX_PLANETS);
     scanf("%f",&NumPlanets);
     if((NumPlanets<NumPlayers)||(NumPlanets>MAX_PLANETS)) NumPlanets
=10;
     printf(MESS_27,NumPlanets);	 
     SplitNum(NumPlanets,&c1[0][3],&c2[0][3]);
     printf(MESS_07);
     scanf("%i",&NumSteps);
     if((NumSteps<1)||(NumSteps>1000)) NumSteps=10;
     SplitNum(NumSteps,&c1[0][4],&c2[0][4]);
     srand(time(0));
     for(i=0;i<NumPlanets;i++)
         {
         PlanetStatus[i]=0;
	 SplitNum(PlanetStatus[i],&c1[i][5],&c2[i][5]);
         PlanetProduct[i]=PRODUCTION+(int)(2*PRODUCTION*rand()/(RAND_MAX + 1.0)); /*change in net*/
         SplitNum(PlanetProduct[i],&c1[i][2],&c2[i][2]);
	 PlanetShips[i]=PlanetProduct[i];
         srand(time(0));
         do {
             x=1+(int)(MAP_SIZE*rand()/(RAND_MAX + 1.0));
	     y=1+(int)(MAP_SIZE*rand()/(RAND_MAX + 1.0));
	    }	 
         while((x>MAP_SIZE-1)||(y>MAP_SIZE-1)||(GetPlanet(x,y)<NumPlanets));
         PlanetCoordX[i]=x;
         PlanetCoordY[i]=y;
	 SplitNum(x,&c1[i][0],&c2[i][0]);
	 SplitNum(y,&c1[i][1],&c2[i][1]);
         }
     for(i=0;i<NumPlayers;i++)
         {
         srand(NumPlanets);
         do {
             j=1+(int)(NumPlanets*rand()/(RAND_MAX+1.0)); /*NumPlanets;
*/
            }
         while(PlanetStatus[j]);
         PlanetStatus[j]=i+1;
	 SplitNum(PlanetStatus[j],&c1[j][5],&c2[j][5]);
         }
    }	 
return;
}
/**************************************************************************/
void Statistics(int p)
{
 printf(MESS_18,GP[p].name);
 printf(MESS_19,GP[p].ships);
if(!GP[p].ships) printf(MESS_45);
 printf(MESS_20,GP[p].planets);
 printf(MESS_21,GP[p].squadrons);
if(!GP[p].squadrons) printf(MESS_45);
 printf(MESS_22,GP[p].destroyed);
 return;
}
/***************************************************************************/
void EnterSrcDst(void)
{ 
 char inp[10];
 printf(MESS_24);  scanf("%s",inp);
 ParseS(inp,&x_gc1,&y_gc1);
 if((x_gc1>=MAP_SIZE)||(x_gc1<0)) x_gc1=0;
 if((y_gc1>=MAP_SIZE)||(y_gc1<0)) y_gc1=0;
 printf(MESS_26);  scanf("%s",inp);
 ParseS(inp,&x_gc2,&y_gc2); 
 if((x_gc2>=MAP_SIZE)||(x_gc2<0)) x_gc2=0;
 if((y_gc2>=MAP_SIZE)||(y_gc2<0)) y_gc2=0;
 return;
}
/***************************************************************************/
int CountDistance(int a,int p,int s)
{
 int dist=0;
 p++;
 N=GetPlanet(y_gc1,x_gc1);
 M=GetPlanet(y_gc2,x_gc2);
 if(N>=NumPlanets)
     {
     draw(s,p+1);
     printf(MESS_14);
     confir_m(WHAT_02);
     draw(s,p+1);
     return dist;
     }
 if(M>=NumPlanets)
     {
     draw(s,p+1);
     printf(MESS_15);
     confir_m(WHAT_02);
     draw(s,p+1);
     return dist;
     }
 if(a)
 { 
     if(PlanetStatus[N]!=p) 
         {
         draw(s,p+1);
	 printf(MESS_16);
         confir_m(WHAT_02);
	 draw(s,p+1);	 
	 return dist;
	 
	 }
 }	 
 dist=(int)(((x_gc2-x_gc1)*(x_gc2-x_gc1)+(y_gc2-y_gc1)*(y_gc2-y_gc1))/(x_gc2-x_gc1+y_gc2-y_gc1));
 if(dist<0) dist=-dist;
 if(!a)
     printf(MESS_17,dist);
 return dist;
}
/***************************************************************************/
void Count_D(int p,int s)
{
 EnterSrcDst();
 CountDistance(0,p,s);
 return;
}
/***************************************************************************/
int Send_S(int p,int s)
{
 int num;/////////////////////////////////////////////
 int i,j;
 EnterSrcDst();
 printf(MESS_31);
 scanf("%d",&num);
 i=CountDistance(1,p,s);
 if(!i) return;
 if((PlanetShips[N]-num)<0)
     {
     draw(s,p+1);
     printf(MESS_23);
     return 0;
     }
 else
     {
     PlanetShips[N]-=num;
     GP[p].ships+=num;
     GP[p].squadrons++;
     j=MergeNum(GP[p].mapH[M][i],GP[p].mapL[M][i]);
     j+=num;
     SplitNum(j,&GP[p].mapH[M][i],&GP[p].mapL[M][i]);
     }
 return 1; 
}
/***************************************************************************/
void Info_P(void)
{
 char inp[10];
 int Np,i;
 printf(MESS_32);  scanf("%s",inp);
 ParseS(inp,&x_gc1,&y_gc1); 
 if((x_gc1>=MAP_SIZE)||(x_gc1<0)) x_gc1=0;
 if((y_gc1>=MAP_SIZE)||(y_gc1<0)) y_gc1=0;
 Np=GetPlanet(y_gc1,x_gc1);
 clrscr();
 printf(MESS_08);
 if((Np>=NumPlanets)||(Np<0))
     printf(MESS_09);
 else
     {
     i=PlanetStatus[Np];
     printf(MESS_10,players[i]);
     printf(MESS_11,(int)(65+3*PRODUCTION-PlanetProduct[Np]));
     printf(MESS_12,PlanetShips[Np]);
     printf(MESS_13,PlanetProduct[Np]);
     }
 return;
}
/***************************************************************************/
int confir_m(char *what)
{
 char c;
 printf(MESS_37,what);
 do {
     c=getc(stdin);
    }
 while((c!='y')&&(c!='n')&&(c!='Y')&&(c!='N'));
 if((c=='y')||(c=='Y')) return 1;
 return 0;
}
/***************************************************************************/
void step(int step)
{
 int i,j,k,l,r,m;
 for(i=0;i<NumPlanets;i++)
     if(PlanetStatus[i]) PlanetShips[i]+=PlanetProduct[i];
     
 for(i=0;i<NumPlayers;i++)
     for(j=0;j<NumPlanets;j++)
         {
	 l=MergeNum(GP[i].mapH[j][1],GP[i].mapL[j][1]);
	 if(l>=BUG_LEVEL) l=0; /*w30976huuppppss!!! lost armada...**/
	 if((PlanetStatus[j]!=(i+1)) && (l))
	     {
	     r=PlanetShips[j];
	     GP[i].mapH[j][1]=0;
	     GP[i].mapL[j][1]=0;
	     
	     if((r-l)<0)
	         {
		 PlanetShips[j]=l-r;
		 PlanetStatus[j]=i+1;
		 GP[i].planets++;
		 GP[i].destroyed+=r;
		 draw(step,i+1);		
		 printf(MESS_28,j,PlanetCoordY[j]+65,PlanetCoordX[j],players[i+1]);
		 confir_m(WHAT_02);
		 }
	      else
		 {
		 PlanetShips[j]=r-l;
		 if(PlanetStatus[j]) GP[(PlanetStatus[j]-1)].destroyed+=l;
		 draw(step,i+1);
		 printf(MESS_29,j,PlanetCoordY[j]+65,PlanetCoordX[j],players[i+1]);
		 confir_m(WHAT_02);
		 }
	     }
	     else if((l<BUG_LEVEL)&&(l>0))
		     {
		     PlanetShips[j]+=l;
		     GP[i].mapH[j][1]=0;
		     GP[i].mapL[j][1]=0;
		 draw(step,i+1);
		 printf(MESS_30,players[i+1],j,PlanetCoordY[j]+65,PlanetCoordX[j]);
		 confir_m(WHAT_02);
		     }
	 for(k=2;k<SPACE;k++)
	    {
	    r=MergeNum(GP[i].mapH[j][k],GP[i].mapL[j][k]);
	    if((r<BUG_LEVEL)&&(r>0))
		{
		GP[i].mapH[j][k]=0;
		GP[i].mapL[j][k]=0;
		
		m=MergeNum(GP[i].mapH[j][k-1],GP[i].mapL[j][k-1]);
		m+=r;
		SplitNum(m,&GP[i].mapH[j][k-1],&GP[i].mapL[j][k-1]);
		}
	    }
     }
 return;
}
/***************************************************************************/
void ExitG(int v)
{
 int w;
 clrscr();
 printf(MESS_34,GP[v].name);
 for(w=0;w<NumPlayers;w++)
     {
     Statistics(w);
     confir_m(WHAT_02);
     }
 return;
}
/***************************************************************************/
int CheckSteps(int step,int p)
{
 int add,k;
 if(step==(NumSteps-1))
     {
      draw(step,p+1);
      printf(MESS_35);
      if(!confir_m(WHAT_03))
         {
	 printf(MESS_36);
         scanf("%i",&add);
         if((add<=0)||(add>1000)) NumSteps++;
         else NumSteps+=add;
	 }
     else
	 {
         clrscr();
	 for(k=0;k<NumPlayers;k++)
    	     {
	     Statistics(k);
	     confir_m(WHAT_02);
	     }
         return 0;
         }
      } 
 return 1;
}
