/* NetGalacticConquest v 1.01b
 * Release date: 26 Jun 2000
 * Copyright 2000 Anatoliy Okhotnikov <cgc@tolik.8k.com>
 *		
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include <stdlib.h>
#include <ctype.h>
#include "conquest.h"
#include "game.h"
#include "msg.h"
#include "netmisc.h"

int main(void)
{
 int choice=6,i,j,k;
 char choic[10];
 clrscr();
 printf(MESS_66);
 do {
     choic[0]=getc(stdin);
     choic[1]='\0';
     if(isdigit(choic[0])) choice=atoi(choic);
     }
 while((choice!=1)&&(choice!=2));
 if(choice==2)
     network_options ();  /*quit_game ();*/
 else
     {     
     init(0,0);
 /*num=0,client=0 -->local game!*/
     draw(1,1);
     for(i=0;i<NumSteps;i++)
	 {
         for(j=0;j<NumPlayers;j++)
    	     {
    	     draw(i,j+1);
    	     do {
	         choic[0]=getc(stdin);
	         if(isdigit(choic[0]))
	         { choic[1]='\0';
	           choice=atoi(choic);
	           switch(choice)
		     {	
		     case 0: { draw(i,j+1);
		               if(confir_m(WHAT_01))
			         {	
			         ExitG(j);
				 quit_game();
			         exit(0);
			         }	
                               draw(i,j+1);    
			       choice=6;
			       break;
			      }
		     case 1: { draw(i,j+1);
		               Info_P();
			       confir_m(WHAT_02);
			       draw(i,j+1);
			       choice=6;
			       break;

                         	}
		     case 2: { draw(i,j+1);
		               if(Send_S(j,i)) draw(j,i+1);
			       choice=6;
			       break;

                             }
		     case 3: { draw(i,j+1);
			       Count_D(j,i);
			       choice=6;

			       break;
			     }  
		     case 4: { clrscr();
			       Statistics(j);
			       confir_m(WHAT_02);
			       draw(i,j+1);
			       choice=6;
			       break;
			     }
	           }
		}   	 
	    }
	    while(choice!=5);
	    choice=6;
	    }
       step(i);
	
       CheckSteps(i,0);    	
       }
    }           
return 0;
}

void network_options (void)
{
  int selection;
  printf (MESS_38);
  scanf ("%d", &selection);
  if (selection == 1)
    {
      server_start ();
    }
  else if (selection == 2)
    {
    client_start ();
    }
}

int server_start (void)
{
/****************Server-Player1-GP[0]-players[1]**********************/
  int transf_bytes,i,j,k;
  char buf[MAXDATASIZE];
  char local_ip_address[20];
  char peer_ip_address[20];
  init(2,0); /*num=2,client=0-->network game!*/
  /*printf (MESS_40);*/
  for(i=0;i<strlen(GP[0].name);i++) *(player1_name+i)=*(GP[0].name+i);
  *(player1_name+i+1)='\0';
  strcpy (local_ip_address, give_local_IP ());
  printf (MESS_41);
  printf (MESS_42, player1_name);

  server_write_sock = establish_listening_socket (SERVER_PORT_NUMBER, peer_ip_address);
  transf_bytes = write_to_socket (server_write_sock, player1_name, 20);

  sleep ( 2 );

  server_read_sock = connect_to_socket (peer_ip_address, CLIENT_PORT_NUMBER);

  transf_bytes = read (server_read_sock, player2_name, 20);
  for(i=0;i<strlen(player2_name);i++)
      *(players[2]+i)=*(player2_name+i);  
  *(players[2]+i+1)='\0';

  GP[1].name=players[2];

  printf (MESS_43, player2_name);

  printf (MESS_44);
  sleep ( 3 );

  printf (MESS_46, player1_name);
  transf_bytes = write_to_socket (server_write_sock, player1_name, 20);

  printf (MESS_47);
  sleep ( 2 );
/************************Transfer data to client!**********************/  
  /**Sending planets...**/
  transf_bytes = write_to_socket (server_write_sock, &c1[0][3], 1);
  transf_bytes = write_to_socket (server_write_sock, &c2[0][3], 1);
  /**Sending steps...**/
  transf_bytes = write_to_socket (server_write_sock, &c1[0][4], 1);
  transf_bytes = write_to_socket (server_write_sock, &c2[0][4], 1);
  /**Sending planets coords...**/
  for(i=0;i<NumPlanets;i++)
    { /**Sending X**/
      transf_bytes = write_to_socket (server_write_sock, &c1[i][0], 1);
      transf_bytes = write_to_socket (server_write_sock, &c2[i][0], 1);
      /**Sending Y**/
      transf_bytes = write_to_socket (server_write_sock, &c1[i][1], 1);
      transf_bytes = write_to_socket (server_write_sock, &c2[i][1], 1);
      /**Sending PlanetProduct**/
      transf_bytes = write_to_socket (server_write_sock, &c1[i][2], 1);
      transf_bytes = write_to_socket (server_write_sock, &c2[i][2], 1);      
      /**Sending PlanetStatus**/
      transf_bytes = write_to_socket (server_write_sock, &c1[i][5], 1);
      transf_bytes = write_to_socket (server_write_sock, &c2[i][5], 1);            
    }  
    
  draw(1,0); 
  for(k=0;k<NumPlayers;k++)
    /*  for(i=0;i<NumPlanets;i++)
         for(j=0;j<SPACE;j++) */
             {
/*	     GP[k].mapH[i][j]=0;
	     GP[k].mapL[i][j]=0;*/
	     memset(GP[k].mapH,0,MAX_PLANETS*SPACE-1);
	     memset(GP[k].mapL,0,MAX_PLANETS*SPACE-1);
	     }
  /*exit(0);*/
  init_server_network_game ();
}

void client_start (void)
{
/****************Client-Player2-GP[1]-players[2]**********************/
  int transf_bytes,i,j,k;
  char buf[MAXDATASIZE];
  char host_ip_number[20];
  char peer_ip_address[20];
  init(2,1); /*num=2,client=1-->network game!*/
/*  printf (MESS_48);
  scanf ("%s", player2_name);*/
  for(i=0;i<strlen(GP[1].name);i++) *(player2_name+i)=*(GP[1].name+i);
  *(player2_name+i+1)='\0';
/*  player2_name=GP[0].name;*/
  printf (MESS_49);
  scanf ("%s", &host_ip_number);
  printf (MESS_50);

  client_read_sock = connect_to_socket (host_ip_number, SERVER_PORT_NUMBER);

  printf (MESS_51);
  transf_bytes = read_from_socket (client_read_sock, player1_name, 20);
  for(i=0;i<strlen(player1_name);i++)
       *(players[1]+i)=*(player1_name+i);  
       *(players[1]+i+1)='\0';
  GP[0].name=players[1];

  printf (MESS_52, player1_name);
  printf (MESS_53, player2_name);

  client_write_sock = establish_listening_socket (CLIENT_PORT_NUMBER, peer_ip_address);
  transf_bytes = write_to_socket (client_write_sock, player2_name, 20);

  printf (MESS_44);
  sleep ( 3 );

  printf (MESS_55);

  transf_bytes = read_from_socket (client_read_sock, buf, 20);
  printf (MESS_56, buf);
  sleep ( 2 );
/************************Transfer data from server!**********************/  
  /**Getting planets...**/
  transf_bytes = read_from_socket (client_read_sock, &c1[0][3], 1);
  transf_bytes = read_from_socket (client_read_sock, &c2[0][3], 1);
  NumPlanets=MergeNum(c1[0][3],c2[0][3]);
  /**Gentting steps...**/
  transf_bytes = read_from_socket (client_read_sock, &c1[0][4], 1);
  transf_bytes = read_from_socket (client_read_sock, &c2[0][4], 1);
  NumSteps=MergeNum(c1[0][4],c2[0][4]);
  /**Getting planets coords...**/
  for(i=0;i<NumPlanets;i++)
    { /**Getting X**/
      transf_bytes = read_from_socket (client_read_sock, &c1[i][0], 1);
      transf_bytes = read_from_socket (client_read_sock, &c2[i][0], 1);
      PlanetCoordX[i]=MergeNum(c1[i][0],c2[i][0]);
      /**Getting Y**/
      transf_bytes = read_from_socket (client_read_sock, &c1[i][1], 1);
      transf_bytes = read_from_socket (client_read_sock, &c2[i][1], 1);
      PlanetCoordY[i]=MergeNum(c1[i][1],c2[i][1]);
      /**Getting PlanetProduct**/
      transf_bytes = read_from_socket (client_read_sock, &c1[i][2], 1);
      transf_bytes = read_from_socket (client_read_sock, &c2[i][2], 1);      
      PlanetProduct[i]=MergeNum(c1[i][2],c2[i][2]);
      PlanetShips[i]+=PlanetProduct[i];
      /**Getting PlanetStatus**/
      transf_bytes = read_from_socket (client_read_sock, &c1[i][5], 1);
      transf_bytes = read_from_socket (client_read_sock, &c2[i][5], 1);
      PlanetStatus[i]=MergeNum(c1[i][5],c2[i][5]);            
    }  
 draw(1,0);
 for(k=0;k<NumPlayers;k++)
/*      for(i=0;i<NumPlanets;i++)
         for(j=0;j<SPACE;j++) */
             {
/*	     GP[k].mapH[i][j]=0;
	     GP[k].mapL[i][j]=0;*/
	     memset(GP[k].mapH,0,MAX_PLANETS*SPACE-1);
	     memset(GP[k].mapH,0,MAX_PLANETS*SPACE-1);	     
	     }
 /*exit(0);*/
  init_client_network_game ();
}

void init_server_network_game (void)
{
  char y_n[2];
  char choic[2];
  int transf_bytes,i,j=0,choice;
  char buf[MAXDATASIZE];
  char move_done[2]={'n','\0'};
 
  draw(1,0);
  for(i=0;i<NumSteps;i++)
	 {
/*         for(j=0;j<NumPlayers;j++)
*/
    	     {
    	     /*draw(i,0);
*/
    	     do {
	         choic[0]=getc(stdin);
	         if(isdigit(choic[0]))
	         { choic[1]='\0';
	           choice=atoi(choic);
	           switch(choice)
		     {	
		     case 0: { draw(i,0);
		               if(confir_m(WHAT_01))
			         {	
    			    strcpy(move_done,"y");
    			    transf_bytes = write_to_socket (server_write_sock, move_done, 2);
    			    strcpy(move_done,"g");    			    
			    transf_bytes = write_to_socket (server_write_sock, move_done, 2);
			         ExitG(j);
			   
				 quit_game();
			         exit(0);
			         }	
                               draw(i,0);    
			       choice=6;
			       break;
			      }
		     case 1: { draw(i,0);
		               Info_P();
			       confir_m(WHAT_02);
			       draw(i,0);
			       choice=6;
			       break;

                         	}
		     case 2: { draw(i,0);
		               if(Send_S(j,i)) draw(j,0);
			       choice=6;
			       break;

                             }
		     case 3: { draw(i,0);
			       Count_D(j,i);
			       choice=6;

			       break;
			     }  
		     case 4: { clrscr();
			       Statistics(j);
			       confir_m(WHAT_02);
			       draw(i,0);
			       choice=6;
			       break;
			     }
	           }
		}   	 
	    }
	    while(choice!=5);
	choice=6;
        if(!CheckSteps(i,0)) { 
	       strcpy(move_done,"y");	
               transf_bytes = write_to_socket (server_write_sock, move_done, 2);   
	       strcpy(move_done,"g");	
               transf_bytes = write_to_socket (server_write_sock, move_done, 2);      
	       quit_game();
	       exit(0);
			    }     	
        strcpy(move_done,"y");
        transf_bytes = write_to_socket (server_write_sock, move_done, 2);
        strcpy(move_done,"y");
        transf_bytes = write_to_socket (server_write_sock, move_done, 2);	

        /*Marix exchaange server->send/recieve*/
        draw(i,0);/*i-step player2*/
        printf (MESS_57, player2_name);/*Waiting for player2 move...*/
        FillMatrix(0);
        net_game_send_server_matrix ();
        net_game_recv_server_matrix ();
	RefreshMatrix(1);

        step(i);/*do step...*/

	/*End exchange*/
        draw(i,0);/*i-step player2*/	

        strcpy(move_done,"y");
	while(!strcmp(buf,move_done))
            transf_bytes = read_from_socket (server_read_sock, buf, 2);
        /*Ok! He moved!*/
	/*Check if he gave up:*/
        transf_bytes = read_from_socket (server_read_sock, buf, 2);	
/*        transf_bytes = read_from_socket (server_read_sock, buf, 2);		*/
        /*****************????????????????*****************************/
	strcpy(move_done,"g");	
/*        if(strcmp(buf,move_done)==0) { clrscr();*/
        if(!strcmp(move_done,buf)) { clrscr();
	                               ExitG(1);
    	                               quit_game();
			               exit(0);
				      }  
	draw(i,0);			      

       }
   }
  /*quit_game ();*/
}

void init_client_network_game (void)
{
  char y_n[2];
  char choic[2];
  int transf_bytes,i,j=1,choice;
  char buf[MAXDATASIZE];
  char move_done[2];

  draw(1,0);
 /*Step=1, player=1(0+1)*/
  for(i=0;i<NumSteps;i++)
	 {
	 if(i==(NumSteps-1)) NumSteps++;
         /*for(j=0;j<NumPlayers;j++)
*/
    	     {
    	     draw(i,0);  /*step=i, player=1*/
	     printf (MESS_57, player1_name);/*Waiting for player2 move...*/
	     strcpy(move_done,"y");
/*	     while(!strcmp(buf,move_done))*/
	     while(!strcmp(move_done,buf))
		transf_bytes = read_from_socket (client_read_sock, buf, 2);
             /*Ok! He moved!*/
	     /*Check if he gave up:*/
	     transf_bytes = read_from_socket (client_read_sock, buf, 2);		
/*	     transf_bytes = read_from_socket (client_read_sock, buf, 2);		*/
             /******************????????????????????????**************/
	     strcpy(move_done,"g");		
             if(strcmp(move_done,buf)==0) { clrscr();
		                            ExitG(1);
    	    		                    quit_game();
			                    exit(0);
				          }  
             /*Matrix exchange client->recieve/send*/
	     net_game_recv_client_matrix ();
	     RefreshMatrix(0);
	     
             strcpy(move_done,"n");
	     draw(i,0);
    	     do {
	         choic[0]=getc(stdin);
	         if(isdigit(choic[0]))
	         { choic[1]='\0';
	           choice=atoi(choic);
	           switch(choice)
		     {	
		     case 0: { draw(i,0);
		               if(confir_m(WHAT_01))
			         {	
    			    strcpy(move_done,"y");
    			    transf_bytes = write_to_socket (client_write_sock, move_done, 2);
    			    strcpy(move_done,"g");    			    
			    transf_bytes = write_to_socket (client_write_sock, move_done, 2);	
			         ExitG(j);
				 quit_game();
			         exit(0);
			         }	
                               draw(i,0);    
			       choice=6;
			       break;
			      }
		     case 1: { draw(i,0);
		               Info_P();
			       confir_m(WHAT_02);
			       draw(i,0);
			       choice=6;
			       break;

                         	}
		     case 2: { draw(i,0);
		               if(Send_S(j,i)) draw(j,0);
			       choice=6;
			       break;

                             }
		     case 3: { draw(i,0);
			       Count_D(j,i);
			       choice=6;

			       break;
			     }  
		     case 4: { clrscr();
			       Statistics(j);
			       confir_m(WHAT_02);
			       draw(i,0);
			       choice=6;
			       break;
			     }
	           }
		}   	 
	    }
	    while(choice!=5);
    choice=6;

    FillMatrix(1);
    net_game_send_client_matrix ();
    /*End matrix exchange*/
    step(i);
		     

    /*Ok! move done!*/
    strcpy(move_done,"y");
    transf_bytes = write_to_socket (client_write_sock, move_done, 2);
    strcpy(move_done,"y");    
    transf_bytes = write_to_socket (client_write_sock, move_done, 2);    

    printf(MESS_57,player2_name);
    }
  }
  /*quit_game ();*/
}
/*********************Transfer section *************************************/
/*** Transfer server matrix to client **************************************/
net_game_send_server_matrix ()
{
  int transf_bytes;
  int i,j;
  for(i=0;i<MAX_PLANETS;i++)
  {
      for(j=0;j<SPACE;j++) 
            { 
	    transf_bytes = write_to_socket (server_write_sock, &c1[i][j], 1);
	    transf_bytes = write_to_socket (server_write_sock, &c2[i][j], 1);
	    }
 }
}
/*** Receive client matrix on the server side *******************************/
net_game_recv_server_matrix ()
{
  int transf_bytes;
  int i,j;
/*  for(i=0;i<NumPlanets;i++)
      {
      c1[i][0]=0;
      c2[i][0]=0;
      }*/
  for(i=0;i<MAX_PLANETS;i++)
  {
      for(j=0;j<SPACE;j++) 
      {
       transf_bytes = read_from_socket (server_read_sock, &c1[i][j], 1);
       transf_bytes = read_from_socket (server_read_sock, &c2[i][j], 1);
      }
  }
/************************/
  for(i=0;i<MAX_PLANETS;i++)
  {
      for(j=1;j<SPACE;j++) 
      {
       c1[i][j-1]=c1[i][j];
       c2[i][j-1]=c2[i][j];
      }
  c1[i][j]=0;
  c2[i][j]=0;      
  }
/************************/
}
/*** Transfer matrix from client to server *********************************/
net_game_send_client_matrix ()
{
  int transf_bytes;
  int i,j;
  for(i=0;i<MAX_PLANETS;i++)
      {
      for(j=0;j<SPACE;j++) 
      {
       transf_bytes = write_to_socket (client_write_sock, &c1[i][j], 1);
       transf_bytes = write_to_socket (client_write_sock, &c2[i][j], 1);  
      }
  }
}
/*** Receive server matrix on the client side ********************************/
net_game_recv_client_matrix ()
{
  int transf_bytes;
  int i,j;
  for(i=0;i<MAX_PLANETS;i++)
      {
      for(j=0;j<SPACE;j++) 
      {
       transf_bytes = read_from_socket (client_read_sock, &c1[i][j], 1);
       transf_bytes = read_from_socket (client_read_sock, &c2[i][j], 1);     
      }
   }
/************************/
  for(i=0;i<MAX_PLANETS;i++)
  {
      for(j=1;j<SPACE;j++) 
      {
       c1[i][j-1]=c1[i][j];
       c2[i][j-1]=c2[i][j];
      }
  c1[i][j]=0;
  c2[i][j]=0;      
  }
/************************/
}
/***************************************************************************/
void quit_game (void)
{
  printf(MESS_65);
  close (server_read_sock);
  close (server_write_sock);
  close (client_read_sock);
  close (client_write_sock);
  exit (0);
}
/***************************************************************************/
/** EOF              *******************************************************/
/***************************************************************************/

